import { bindActionCreators } from 'redux';
import { connect, Provider } from 'react-redux';
export { Provider } from 'react-redux';

var connect$1 = ((actionCreatorsBinder = bindActionCreators, dispatcher) => {
  return (getState, actions, Component) => {
    return connect(function (state) {
      return {
        state: getState(state)
      };
    }, function (dispatch) {
      dispatcher || (dispatcher = dispatch);
      return {
        actions: actionCreatorsBinder(actions, dispatcher)
      };
    })(Component);
  };
});

var bindApp = (app => {
  var bindActionCreators$$1, getActionName;

  getActionName = type => {
    var actions;
    ({
      actions
    } = app._.constants);
    return Object.keys(actions).reduce((r, c) => {
      if (r !== '') {
        return r;
      }

      if (actions[c] === type) {
        return c;
      } else {
        return r;
      }
    }, '');
  };

  bindActionCreators$$1 = (actions, dispatch) => {
    return Object.keys(actions).reduce((r, c) => {
      return { ...r,
        [`${c}`]: async payload => {
          var action, actionName;
          action = actions[c](payload);
          actionName = getActionName(action.type);
          return await dispatch[actionName](payload);
        }
      };
    }, {});
  };

  return connect$1(bindActionCreators$$1, app.dispatch);
});

export { connect$1 as connect, bindApp as connectBindApp };
