'use strict';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Provider", {
  enumerable: true,
  get: function get() {
    return _reactRedux.Provider;
  }
});
exports.connectBindApp = exports.connect = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));
var _keys = _interopRequireDefault(require("@babel/runtime/core-js/object/keys"));
var _redux = require("redux");
var _reactRedux = require("react-redux");
var connect$1 = function connect$1() {
  var actionCreatorsBinder = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _redux.bindActionCreators;
  var dispatcher = arguments.length > 1 ? arguments[1] : undefined;
  return function (getState, actions, Component) {
    return (0, _reactRedux.connect)(function (state) {
      return {
        state: getState(state)
      };
    }, function (dispatch) {
      dispatcher || (dispatcher = dispatch);
      return {
        actions: actionCreatorsBinder(actions, dispatcher)
      };
    })(Component);
  };
};
exports.connect = connect$1;
var bindApp = function bindApp(app) {
  var bindActionCreators$$1, getActionName;
  getActionName = function getActionName(type) {
    var actions;
    actions = app._.constants.actions;
    return (0, _keys.default)(actions).reduce(function (r, c) {
      if (r !== '') {
        return r;
      }
      if (actions[c] === type) {
        return c;
      } else {
        return r;
      }
    }, '');
  };
  bindActionCreators$$1 = function bindActionCreators$$1(actions, dispatch) {
    return (0, _keys.default)(actions).reduce(function (r, c) {
      return (0, _objectSpread3.default)({}, r, (0, _defineProperty2.default)({}, "".concat(c), function () {
        var _2 = (0, _asyncToGenerator2.default)(
        _regenerator.default.mark(function _callee(payload) {
          var action, actionName;
          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  action = actions[c](payload);
                  actionName = getActionName(action.type);
                  _context.next = 4;
                  return dispatch[actionName](payload);
                case 4:
                  return _context.abrupt("return", _context.sent);
                case 5:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));
        return function _(_x) {
          return _2.apply(this, arguments);
        };
      }()));
    }, {});
  };
  return connect$1(bindActionCreators$$1, app.dispatch);
};
exports.connectBindApp = bindApp;
